﻿/**
 * Copyright 2010 Canonical Ltd.
 * 
 * This file is part of UbuntuOne on Windows.
 * 
 * UbuntuOne on Windows is free software: you can redistribute it and/or modify		
 * it under the terms of the GNU Lesser General Public License version 		
 * as published by the Free Software Foundation.		
 *		
 * Ubuntu One on Windows is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	
 * GNU Lesser General Public License for more details.	
 *
 * You should have received a copy of the GNU Lesser General Public License	
 * along with UbuntuOne for Windows.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Authors: Manuel de la Peña <manuel.delapena@canonical.com>
 */
using System;
using NUnit.Framework;

namespace Canonical.UbuntuOne.Common.Tests
{
    [TestFixture]
    public class SyncDaemonExceptionFixture
    {
        [TestCase("Message 1")]
        [TestCase("Other message")]
        public void MessageConstrcutroTest(string message)
        {
            var exception = new SyncDaemonException(message);
            Assert.AreEqual(message, exception.Message);
        }

        [TestCase("Message 1", typeof(InvalidOperationException))]
        [TestCase("Other Message", typeof(NullReferenceException))]
        public void MessageExceptionConstructorTest(string message, Type exceptionType)
        {
            var innerException = Activator.CreateInstance(exceptionType) as Exception;
            if (innerException != null)
            {
                var exception = new SyncDaemonException(message, innerException);
                Assert.AreEqual(message, exception.Message);
                Assert.IsNotNull(exception.InnerException);
                Assert.AreSame(innerException, exception.InnerException);
            }
        }
    }
}
