﻿/**
 * Copyright 2010 Canonical Ltd.
 * 
 * This file is part of UbuntuOne on Windows.
 * 
 * UbuntuOne on Windows is free software: you can redistribute it and/or modify		
 * it under the terms of the GNU Lesser General Public License version 		
 * as published by the Free Software Foundation.		
 *		
 * Ubuntu One on Windows is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	
 * GNU Lesser General Public License for more details.	
 *
 * You should have received a copy of the GNU Lesser General Public License	
 * along with UbuntuOne for Windows.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Authors: Manuel de la Peña <manuel.delapena@canonical.com>
 */
namespace Canonical.UbuntuOne.Common.Container
{
    /// <summary>
    /// Maps a type to another
    /// </summary>
    /// <typeparam name="TFrom">The type to map from.</typeparam>
    /// <typeparam name="TTo">The type to map to.</typeparam>
    public interface IMapper<TFrom, TTo>
    {
        /// <summary>
        /// Maps the specified from type.
        /// </summary>
        /// <param name="from">Original type to map from</param>
        /// <returns>Returns the targeted type</returns>
        TTo Map(TFrom from);
    }
}
