﻿/**
 * Copyright 2010 Canonical Ltd.
 * 
 * This file is part of UbuntuOne on Windows.
 * 
 * UbuntuOne on Windows is free software: you can redistribute it and/or modify		
 * it under the terms of the GNU Lesser General Public License version 		
 * as published by the Free Software Foundation.		
 *		
 * Ubuntu One on Windows is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	
 * GNU Lesser General Public License for more details.	
 *
 * You should have received a copy of the GNU Lesser General Public License	
 * along with UbuntuOne for Windows.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Authors: Manuel de la Peña <manuel.delapena@canonical.com>
 */
using System.Runtime.Serialization;

namespace Canonical.UbuntuOne.Common
{
    /// <summary>
    /// Base data contract used that should be extended by all those contracts that display node 
    /// information.
    /// </summary>
    [DataContract]
    public class NodeData
    {
        /// <summary>
        /// Gets and sets the path of the download.
        /// </summary>
        [DataMember]
        public string Path { get; set; }

        /// <summary>
        /// Gets and sets the unique id share.
        /// </summary>
        [DataMember]
        public string VolumeId { get; set; }

        /// <summary>
        /// Gets and sets the unique id of the noode.
        /// </summary>
        [DataMember]
        public string NodeId { get; set; }
    }
}
