﻿/**
 * Copyright 2010 Canonical Ltd.
 * 
 * This file is part of UbuntuOne on Windows.
 * 
 * UbuntuOne on Windows is free software: you can redistribute it and/or modify		
 * it under the terms of the GNU Lesser General Public License version 		
 * as published by the Free Software Foundation.		
 *		
 * Ubuntu One on Windows is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	
 * GNU Lesser General Public License for more details.	
 *
 * You should have received a copy of the GNU Lesser General Public License	
 * along with UbuntuOne for Windows.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Authors: Manuel de la Peña <manuel.delapena@canonical.com>
 */
using System.Runtime.Serialization;

namespace Canonical.UbuntuOne.Common
{
    [DataContract]
    public class ShareData : NodeData
    {
        /// <summary>
        /// Gets and sets the name of the share.
        /// </summary>
        [DataMember]
        public string Name { get; set; }

        /// <summary>
        /// Gets and sets the username of the user that shared the name.
        /// </summary>
        [DataMember]
        public string OtherUserName { get; set; }

        /// <summary>
        /// The visisble name of the user. As a user you have a username: mande and a name: Manuel de la Pena
        /// this property returns the name: Manuel de la Pena.
        /// </summary>
        [DataMember]
        public string OtherVisisbleName { get; set; }

        /// <summary>
        /// Gets and sets if the share was accepted.
        /// </summary>
        [DataMember]
        public bool IsAccepted { get; set; }

        /// <summary>
        /// Gets and sets the access level that the user has in the share.
        /// </summary>
        [DataMember]
        public AccessLevel AccessLevel { get; set; }

        /// <summary>
        /// Gets and sets the amount of bytes that you can add to the share.
        /// </summary>
        [DataMember]
        public int FreeBytes { get; set; }
    }
}
