﻿/**
 * Copyright 2010 Canonical Ltd.
 * 
 * This file is part of UbuntuOne on Windows.
 * 
 * UbuntuOne on Windows is free software: you can redistribute it and/or modify		
 * it under the terms of the GNU Lesser General Public License version 		
 * as published by the Free Software Foundation.		
 *		
 * Ubuntu One on Windows is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	
 * GNU Lesser General Public License for more details.	
 *
 * You should have received a copy of the GNU Lesser General Public License	
 * along with UbuntuOne for Windows.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Authors: Manuel de la Peña <manuel.delapena@canonical.com>
 */
using System.Runtime.Serialization;

namespace Canonical.UbuntuOne.Common
{
    /// <summary>
    /// Data contract used to state of the daemon.
    /// </summary>
    [DataContract]
    public class StateData
    {
        //TOdO: This should be an enum, never a string

        /// <summary>
        /// Gets and sets the name of the state.
        /// </summary>
        [DataMember]
        public string Name { get; set; }

        /// <summary>
        /// Gets and sets the description of the state.
        /// </summary>
        [DataMember]
        public string Description { get; set; }

        /// <summary>
        /// Gets and sets if the state is an error.
        /// </summary>
        [DataMember]
        public bool IsError { get; set; }

        /// <summary>
        /// Gets and sets if the daemon is connected or not.
        /// </summary>
        [DataMember]
        public bool IsConnected { get; set; }

        /// <summary>
        /// Gets and sets of the daemon is online or not.
        /// </summary>
        [DataMember]
        public bool IsOnline { get; set; }
    }
}
