﻿/**
 * Copyright 2010 Canonical Ltd.
 * 
 * This file is part of UbuntuOne on Windows.
 * 
 * UbuntuOne on Windows is free software: you can redistribute it and/or modify		
 * it under the terms of the GNU Lesser General Public License version 		
 * as published by the Free Software Foundation.		
 *		
 * Ubuntu One on Windows is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	
 * GNU Lesser General Public License for more details.	
 *
 * You should have received a copy of the GNU Lesser General Public License	
 * along with UbuntuOne for Windows.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Authors: Manuel de la Peña <manuel.delapena@canonical.com>
 */
using System.Collections.Generic;
using System.ServiceModel;

namespace Canonical.UbuntuOne.Common
{
    /// <summary>
    /// Service that provides method to interact with the FileManager used by the sync daemon.
    /// </summary>
    [ServiceContract(
        Name = "SyncFileManager",
        Namespace = "http://one.ubuntu.com/syncfilemanager",
        CallbackContract = typeof(ISyncDaemonClient),
        SessionMode = SessionMode.Required)]
    public interface ISyncFileManager
    {

        [OperationContract]
        IDictionary<string, string> GetMetadata(string path);
    }
}
