﻿using System.ServiceModel;

namespace Canonical.UbuntuOne.Common
{
    /// <summary>
    /// Explicit iimplementation of the IAuthentication interface that allows to ensure that the 
    /// user that calls the service has the correct rights.
    /// </summary>
    class SyncDaemonAuthentication : IAuthentication
    {
        /// <summary>
        /// Gets if the current user is authenticated or not.
        /// </summary>
        public bool IsAuthenticated
        {
            get { return ServiceSecurityContext.Current.PrimaryIdentity.IsAuthenticated; }
        }

        /// <summary>
        /// Gets the username of the current user.
        /// </summary>
        public string Username
        {
            get { return ServiceSecurityContext.Current.PrimaryIdentity.Name; }
        }
    }
}
