﻿/**
 * Copyright 2010 Canonical Ltd.
 * 
 * This file is part of UbuntuOne on Windows.
 * 
 * UbuntuOne on Windows is free software: you can redistribute it and/or modify		
 * it under the terms of the GNU Lesser General Public License version 		
 * as published by the Free Software Foundation.		
 *		
 * Ubuntu One on Windows is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	
 * GNU Lesser General Public License for more details.	
 *
 * You should have received a copy of the GNU Lesser General Public License	
 * along with UbuntuOne for Windows.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Authors: Manuel de la Peña <manuel.delapena@canonical.com>
 */
using System;
using DotUpdater;
using log4net;

namespace Canonical.UbuntuOne.Common.Update
{
    internal class DotLogger : Logger
    {
        private readonly ILog _logger = LogManager.GetLogger(typeof(Updater));

        public override void LogWarning(string info)
        {
            _logger.Warn(info);
            base.LogWarning(info);
        }

        public override void LogException(Exception e)
        {
            _logger.Error(e);
            base.LogException(e);
        }

        public override void LogAndThrowException(Exception exception)
        {
            _logger.Error(exception);
            base.LogAndThrowException(exception);
        }
    }
}
