﻿/**
 * Copyright 2010 Canonical Ltd.
 * 
 * This file is part of UbuntuOne on Windows.
 * 
 * UbuntuOne on Windows is free software: you can redistribute it and/or modify		
 * it under the terms of the GNU Lesser General Public License version 		
 * as published by the Free Software Foundation.		
 *		
 * Ubuntu One on Windows is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	
 * GNU Lesser General Public License for more details.	
 *
 * You should have received a copy of the GNU Lesser General Public License	
 * along with UbuntuOne for Windows.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Authors: Manuel de la Peña <manuel.delapena@canonical.com>
 */
using System;
using DotUpdater;
using Microsoft.ApplicationBlocks.Updater;

namespace Canonical.UbuntuOne.Common.Update
{
    internal class DotUpdaterWrapper : IDotUpdaterWrapper
    {
        #region Events

        public event EventHandler<TaskEventArgs> OnDownloadCompleted;
        public event EventHandler<DownloadTaskProgressEventArgs> OnDownloadProgress;
        public event EventHandler<DownloadTaskErrorEventArgs> OnDownloadError;

        #endregion

        #region Variables

        private DotUpdater.Updater _updater;

        #endregion

        public DotUpdaterWrapper(Logger logger, string rss)
        {
            _updater = new DotUpdater.Updater(logger, rss);
            OnDownloadCompleted = _updater.OnDownloadCompleted;
            OnDownloadProgress = _updater.OnDownloadProgress;
            OnDownloadError = _updater.OnDownloadError;
        }

        public UpdaterTask CheckForUpdates()
        {
            return _updater.CheckForUpdates();
        }

        public void Install(UpdaterTask task)
        {
            _updater.Install(task);
        }

        public void BeginDownload(UpdaterTask task)
        {
            _updater.BeginDownload(task);
        }

        public void Dispose()
        {
            _updater.Dispose();
        }
    }
}
