﻿/**
 * Copyright 2010 Canonical Ltd.
 * 
 * This file is part of UbuntuOne on Windows.
 * 
 * UbuntuOne on Windows is free software: you can redistribute it and/or modify		
 * it under the terms of the GNU Lesser General Public License version 		
 * as published by the Free Software Foundation.		
 *		
 * Ubuntu One on Windows is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	
 * GNU Lesser General Public License for more details.	
 *
 * You should have received a copy of the GNU Lesser General Public License	
 * along with UbuntuOne for Windows.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Authors: Manuel de la Peña <manuel.delapena@canonical.com>
 */
using NUnit.Framework;

namespace Canonical.UbuntuOne.ProcessDispatcher.Tests.Protobuf
{

    [TestFixture]
    public class SyncDaemonMessageFactoryFixture
    {
        #region Setup

        private SyncDaemonMessageFactory _factory;

        [SetUp]
        public void Setup()
        {
            _factory = new SyncDaemonMessageFactory();
        }

        #endregion

        [Test]
        public void QueryStateTest()
        {
            var message = _factory.QueryState();
            Assert.AreEqual(SyncDaemonMessage.MessageType.QUERYSTATUS, message.Type);
        }

        [Test]
        public void QueryRootTest()
        {
            var message = _factory.QueryRoot();
            Assert.AreEqual(SyncDaemonMessage.MessageType.QUERYROOT, message.Type);
        }

        [Test]
        public void QueryDownloadsTest()
        {
            var message = _factory.QueryDownloads();
            Assert.AreEqual(SyncDaemonMessage.MessageType.QUERYDOWNLOADS, message.Type);
        }

        [Test]
        public void QueryWaitingTest()
        {
            var message = _factory.QueryWaiting();
            Assert.AreEqual(SyncDaemonMessage.MessageType.QUERYWAITING, message.Type);
        }

        [Test]
        public void QueryUploadsTest()
        {
            var message = _factory.QueryUploads();
            Assert.AreEqual(SyncDaemonMessage.MessageType.QUERYUPLOADS, message.Type);
        }
    }
}
