﻿/**
 * Copyright 2010 Canonical Ltd.
 * 
 * This file is part of UbuntuOne on Windows.
 * 
 * UbuntuOne on Windows is free software: you can redistribute it and/or modify		
 * it under the terms of the GNU Lesser General Public License version 		
 * as published by the Free Software Foundation.		
 *		
 * Ubuntu One on Windows is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	
 * GNU Lesser General Public License for more details.	
 *
 * You should have received a copy of the GNU Lesser General Public License	
 * along with UbuntuOne for Windows.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Authors: Manuel de la Peña <manuel.delapena@canonical.com>
 */
using System.ServiceProcess;
using Canonical.UbuntuOne.Common.Container;
using log4net;

namespace Canonical.UbuntuOne.ProcessDispatcher
{
	static class Program
	{
	    private static ILog _logger = LogManager.GetLogger(typeof (Program));

		/// <summary>
		/// This method starts the service.
		/// </summary>
		static void Main()
		{
            _logger.Debug("Starting services.");
            // use the IoC to get the implementation of the SyncDaemon service, the IoC will take care of 
            // setting the object correctly.
            ObjectsContainer.Initialize(new SpringContainer());
            var syncDaemonWindowsService = ObjectsContainer.GetImplementationOf<SyncDaemonWindowsService>();
            
			// To run more than one service you have to add them here
            ServiceBase.Run(new ServiceBase[] { syncDaemonWindowsService });
		}
	}
}
