﻿/**
 * Copyright 2010 Canonical Ltd.
 * 
 * This file is part of UbuntuOne on Windows.
 * 
 * UbuntuOne on Windows is free software: you can redistribute it and/or modify		
 * it under the terms of the GNU Lesser General Public License version 		
 * as published by the Free Software Foundation.		
 *		
 * Ubuntu One on Windows is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	
 * GNU Lesser General Public License for more details.	
 *
 * You should have received a copy of the GNU Lesser General Public License	
 * along with UbuntuOne for Windows.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Authors: Manuel de la Peña <manuel.delapena@canonical.com>
 */
using Canonical.UbuntuOne.Common;
using Canonical.UbuntuOne.Common.Validation;

namespace Canonical.UbuntuOne.ProcessDispatcher
{
    internal class SyncConfigurationMessageFactory : ISyncConfigurationMessageFactory
    {

        public ConfigurationMessage QueryThrottling()
        {
            return new ConfigurationMessage { Type = ConfigurationMessage.MessageType.QUERYTHROTTLING };
        }

        public ConfigurationMessage SetThrottlingLimits(ThrottlingData data)
        {
            ValidateArgs.Begin()
                .IsNotNull(data)
                .Check();
            return new ConfigurationMessage
            {
                Type = ConfigurationMessage.MessageType.SETTHROTTLING,
                Throttling = new ConfigurationMessage.ThrottlingLimitsMessage
                {
                    Download = data.Download,
                    Upload = data.Upload
                }
            };
        }

        public ConfigurationMessage EnableThrottling(bool isEnabled)
        {
            return new ConfigurationMessage
            {
                Type = ConfigurationMessage.MessageType.ENABLETHROTTLING,
                ThrottlingEnabled = isEnabled
            };
        }

        public ConfigurationMessage EnablesAutosubscribe(bool isEnabled)
        {
            return new ConfigurationMessage
            {
                Type = ConfigurationMessage.MessageType.ENABLEAUTOSUBSCRIBE,
                AutosubscribeEnabled = isEnabled
            };
        }
    }
}
