/**
 * Copyright 2010 Canonical Ltd.
 * 
 * This file is part of UbuntuOne on Windows.
 * 
 * UbuntuOne on Windows is free software: you can redistribute it and/or modify		
 * it under the terms of the GNU Lesser General Public License version 		
 * as published by the Free Software Foundation.		
 *		
 * Ubuntu One on Windows is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	
 * GNU Lesser General Public License for more details.	
 *
 * You should have received a copy of the GNU Lesser General Public License	
 * along with UbuntuOne for Windows.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Authors: Manuel de la Peña <manuel.delapena@canonical.com>
 */
using System.Collections.Generic;

namespace Canonical.UbuntuOne.ProcessDispatcher
{
	/// <summary>
	/// Due to the fact that the SyncDaemonMessage is auto generated by the proto-gen tool we 
	/// would not be able to add code without loosing it. In order to allow the use of custom code
	/// we use extension methods. 
	/// </summary>
	public partial class SyncDaemonMessage
	{
        /// <summary>
        /// Allows the creation of a new sync dameon message with a collection of downloads. This constructor
        /// has been added because the generated code does not provide setter for collections in the proto messages.
        /// </summary>
        /// <param name="downloads">A collection of downloads to be added in the message.</param>
	    internal SyncDaemonMessage(List<DownloadMessage> downloads)
	    {
	        _downloads = downloads;
	    }

        /// <summary>
        /// Allows the creation of a new sync daemon message with a collection of queued items. This constructor
        /// has been added because the generated code does not provide a setter for collections in the proto messages.
        /// </summary>
        /// <param name="queuItemMessages">A collection of queued items added to the message.</param>
	    internal SyncDaemonMessage(List<QueuItemMessage> queuItemMessages)
	    {
	        _waitingItems = queuItemMessages;
	    }

        /// <summary>
        /// Allows the creates of a new sync message with a collection of uploads. This constrcutor has been added
        /// because the generated code does not provide a setter for the collections in the proto message.
        /// </summary>
        /// <param name="uploads">A collection of uploads.</param>
        internal SyncDaemonMessage(List<UploadMessage> uploads)
        {
            _uploads = uploads;
        }
	}
}

